/* Connect2SCF.h
--------------------------------------------------------------------------
 connect ե뤫鹽¤ե
--------------------------------------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;   // <-- ɲäNov. 7, 2007. YT

  const int maxcomp = 50;
  const int maxrpsp = 1000;
  const int maxchar = 256;

// 饹 Connect2SCF 
class Connect2SCF {

 protected:
  int* seg_no;                                     /* ƻʬֹ */
  int* sigma_up;                   /* ήüܤƤƻʬ */
  int* sigma_down;                 /* ή¦ܤƤƻʬ */
  int** mu_up;                 /* ή¦ܤƤƻʬֹ */
  int** mu_down;               /* ή¦ܤƤƻʬֹ */
  int Num_of_Seg;                                    /* ƻʬ */

  int* need_seg;      /* ʬɬȽ ɬפʤ飱ɬפǤʤУ*/
  int* removed_seg;                        /* ƹֹѴ */
  int* Seg_Type;   /* ȥסʲдоήоήв*/
  char* ref_up;                        /* ή¦ե󥹥 */
  char* ref_down;                      /* ή¦ե󥹥 */
  int Num_Of_Need_Seg;                           /* ɬײƻʬ */
  int Num_Of_Removed;                /* õƻȿ */

  char* file_file;                          /* ե̾ե */

  char connect_file[256];                  /* ³طեݥ */
  char extracted_file2[256];        /* ʬPFV2եݥ */
  char removed_segment_file[256];  /* ƹƻбեݥ */
  char header_file[256];                   /* ¤إåե */
  char scf_file[256];                      /* ¤եݥ */
  char pmt_file[256];                     /* ¤ѥѥ᥿ե */
  char ist_file[256];                 /* ¤ѽե */
  char dif_file[256];                                /*ʬήե*/
  char difin_file[256];                        /* ʬήϥե */
  char attr_file[256];    /* ƻ°եIDֹ桤Ĺɸ⺹ۡ*/
  char width_file[256];                 /* ƻե (IDֹ桤ƻ) */

  int Num_Of_Receive;                            /* ݡȤο */
  int Num_Of_Send;                               /* ݡȤο */
  int Num_Of_Comp_Type;                        /* ǥפ */
  int Num_Of_Components;                       /* ǥǥ */
  
  int  Id_Rp[maxrpsp];                         /* ݡȤIDֹ */
  char Objname_Rp[maxrpsp][maxchar]; /* ݡȤΥ֥̾ */
  int  Objnum_Rp[maxrpsp];          /* ݡȤΥֹ֥ */
  char Classname_Rp[maxrpsp][maxchar];     /* ݡȤΥ饹̾ */
  char Porttype_Rp[maxrpsp][maxchar];  /* ݡȤΥݡȥ */
  
  char Objname_Cp[maxcomp][maxchar];/* ǥǥΥ֥̾ */
  char Classname_Cp[maxcomp][maxchar];    /* ǥǥΥ饹̾ */
  
  int  Id_Sp[maxrpsp];                        /* ݡȤIDֹ */
  char Objname_Sp1[maxrpsp][maxchar]; /* ݡȤΥ֥̾ */
  char Objname_Sp2[maxrpsp][10]; /* ݡȤΥ֥̾ */
  int  Objnum_Sp[maxrpsp];          /* ݡȤΥֹ֥ */
  char Classname_Sp[maxrpsp][maxchar];     /* ݡȤΥ饹̾ */
  char Porttype_Sp[maxrpsp][maxchar];  /* ݡȤΥݡȥ */

  int Total_Num_Of_Dif;                              /* ʬή */
  int* Dif_Num;                              /* ʬήξή¦ֹ */
  int* Num_Of_Dif;                                       /* ʬ */
  int** Dif_Down_Num;                        /* ʬήβή¦ֹ */
  float** Ratio;                                 /* ʬήʬΨ */

  char Ec1[maxchar];
  char Ec2[maxchar];
  char Pmt1[maxchar];
  char Pmt2[maxchar];
  char Ist1[maxchar];
  char Ist2[maxchar];

  int Timestep;                                      /* KsedgeFc2d η׻ॹƥå */
  char InitialTime[maxchar];                         /* Ist ˵Ҥλ */

  double Rainfall_Coordinatex, Rainfall_Coordinatey; /* PmtեϤ߱ʬǽ */
  double Rainfall_Resolutionx, Rainfall_Resolutiony; /* PmtեϤ߱ɸ */

  //double WholeCatchmentArea;      /* ήѡGlumpslp2dνѡ*/
  //double InitialDischarge;       /* ήǲήüνή̡Glumpslp2dνѡ*/
  double ManningRiver;           /* ƻޥ˥ٷ */

  char SetagawaPmt[maxchar];     /* ǥΥѥ᥿ե */
  char SetagawaIst[maxchar];     /* ǥνե */

 public:
  // 󥹥ȥ饯
  Connect2SCF(char* c_file_file);

  Connect2SCF(void){}

  // ǥȥ饯
  ~Connect2SCF(void){}

 public:
  void Read_Connect(void);
  // ³եɤ߹ࡥ

 public:
  void Read_Extracted(void);
  // ʬ Plain Format V.2ɤ߹.

 public:
  void Read_Removed_Segment(void);
  // ƹremoveSegment)ƻбɽɤ߹.

 public:
  void Read_Header(void);
  // ¤إåեɤ߹ࡥ

 public:
  void Read_Diffluence(void);
  // ʬήեɤ߹.

 public:
  void Write_SCF(void);
  // SCFեϤ롣

 public:
  int Dif_R;
  // ʬήեɤ߹(1)(0)
};
