/* Read_Connect.cc */
#include "Connect2SCF.h"

void Connect2SCF :: Read_Connect()
{
	FILE* fp_connect;
	char buf[256];
	char* pbuf;
	int n_seg;
	int segment = -1;
	int i,j;
	int seg_no_tmp;
	int sigma_up_tmp;
	int sigma_down_tmp;
	int mu_up_tmp;
	int mu_down_tmp;

	if((fp_connect = fopen(connect_file, "r")) == NULL){
		printf("Connect2SCF\n");
		printf("Cannot open input file.\n");
		exit(1);
	}

	/* ƻʬ³եˤƻʬμ */
	while(fgets(buf, 256, fp_connect) != NULL){
		if(strcmp(buf, "[Number]\n") != 0) continue;
		if(buf[0] == ' ' || buf[0] == '#') continue;
		// [Number]ˤ.
	        fgets(buf, 256, fp_connect);
		if(sscanf(buf, "%d", &n_seg) != 1){
		  printf("[Number] is needed.\n");
		  exit(1);
		}
		Num_of_Seg = n_seg;  // 
		printf("Number of Segment = %d\n", Num_of_Seg); // ƻʬμ */
		break;
	}

	/* γ */
	seg_no = new int[Num_of_Seg];     // seg_no[i] ˼ʬβƻʬֹǼ
	sigma_up = new int[Num_of_Seg];   // sigma_up[i] ˾ήƻʬθĿǼ
	sigma_down = new int[Num_of_Seg]; // sigma_down[i] ˲ήƻʬθĿǼ
	mu_up = new int*[Num_of_Seg];     // mu_up[i][j] ˾ήƻʬֹǼ
	mu_down = new int*[Num_of_Seg];   // mu_down[i][j] ˲ήƻʬֹǼ
	Seg_Type = new int[Num_of_Seg];
	
	// Seg_TypeΥ
	for(i = 0; i < Num_of_Seg; i++){
		Seg_Type[i] = 0;
		i++;
	}
	/* ͤγǼ */
       	while(fgets(buf, 256, fp_connect) != NULL){
		// [Data]õ
		if(strcmp(buf, "[Data]\n") != 0) continue;
		// [Data]ˤ
		i = 0;		// βƻʬֹ(seg_no[i]i)
		while(fgets(buf, 256, fp_connect) != NULL){
		  pbuf = buf;
		  if(i == Num_of_Seg){
		    printf("Too many information.\n");
		    exit(1);
		  }
		  if(sscanf(pbuf, "%d", &seg_no_tmp) != 1){
		    printf("Cannot scan seg_no.\n");
		    exit(1);
		  }
		  if(seg_no_tmp <= 0){
		    printf("seg_no is negative or zero");
		    exit(1);
		  }
		  seg_no[i] = seg_no_tmp; // seg_no[i] ˼ʬβƻʬֹǼ
		  
		  while(*pbuf != ':') pbuf++;
		  pbuf++;
		  
		  if(sscanf(pbuf, "%d", &sigma_up_tmp) != 1){
		    printf("sigma_up_tmp cannot be read");
		    exit(1);
		  }
		  if((sigma_up_tmp < 0) & (sigma_up_tmp != -1) & (sigma_up_tmp) != -2){
		    printf("sigma_up_tmp = %d", sigma_up_tmp);
		    exit(1);
		  }
		  sigma_up[i] = sigma_up_tmp; 
			
		  while(*pbuf != ':') pbuf++;
		  pbuf++;
		  
		  if(sigma_up[i] > 0){
		    mu_up[i] = new int[sigma_up[i]];
		    for (j=0; j < sigma_up[i]; j++){
		      while((*pbuf == ' ') || (*pbuf =='\t')) pbuf++;
		      if(sscanf(pbuf, "%d", &mu_up_tmp) != 1){
			printf("cannot scan mu_up : %d %d %d\n", i,j,mu_up_tmp);
			exit(1);
		      }
		      mu_up[i][j] = mu_up_tmp;					
		      while ((*pbuf != ' ') && (*pbuf != '\t')) pbuf++;
		    }
		  }
		  else if(sigma_up[i] == 0){
		    mu_up[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_up_tmp) != 1){
		      printf("cannot scan mu_up when sigma_up equals to zero.");
		      exit(1);
		    }
		    else{
		      //  rpu_no[mu_up_tmp] = seg_no[i];
		    }
		  }
		  else if(sigma_up[i] == -2){ // sigma_up = 0 & mu_up = 0 : д (Type 2)
		    mu_up[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_up_tmp) != 1){
		      printf("cannot scan mu_up when sigma_up equals to -2.");
		      exit(1);
		    }
		    else{
		      Seg_Type[i] = 2;
		      //  rpu_no[mu_up_tmp] = seg_no[i];
		    }
		  }
		  else {  // sigma_up[i] = -1 : о¤ή 
		    mu_up[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_up_tmp) != 1){
		      printf("cannot scan mu_up when sigma_up equals to -1.");
		      exit(1);
		    }
				// rpu_no[mu_up_tmp] = -1;
		    Seg_Type[i] = 4;  // о¤ήв (Type 4)
		  }
		  
		  while(*pbuf != ':') pbuf++;
		  pbuf++;
		  
		  if(sscanf(pbuf, "%d", &sigma_down_tmp) != 1){
		    printf("sigma_down_tmp cannot be read");
		    exit(1);
		  }
		  if((sigma_down_tmp < 0) & (sigma_down_tmp != -1) & (sigma_down_tmp != -2)){
		    printf("sigma_down_tmp = %d", sigma_down_tmp);
		    exit(1);
		  }
		  sigma_down[i] = sigma_down_tmp;
		  
		  while(*pbuf != ':') pbuf++;
		  pbuf++;
		  
		  if(sigma_down[i] > 0){
		    mu_down[i] = new int[sigma_down[i]];
		    for (j=0; j < sigma_down[i]; j++){
		      while((*pbuf == ' ') || (*pbuf =='\t')) pbuf++;
		      if(sscanf(pbuf, "%d", &mu_down_tmp) != 1){
			printf("cannot scan mu_down: i = %d : j = %d", i, j);
			exit(1);
		      }
		      mu_down[i][j] = mu_down_tmp;
		      while ((*pbuf != ' ') && (*pbuf != '\t')) pbuf++;
		    }
		  }
		  else if(sigma_down[i] == 0){
		    mu_down[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_down_tmp) != 1){
		      printf("cannot scan mu_down when sigma_down equals to zero.");
		      exit(1);
		    }
				// sp_no[mu_down_tmp] = seg_no[i];
		  }
		  else if(sigma_down[i] == -1){		// sigma_down[i] = -1 : о¤ؤή 
		    mu_down[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_down_tmp) != 1){
		      printf("cannot scan mu_down when sigma_down equals to -1.");
		      exit(1);
		    }
				// sp_no[mu_down_tmp] = -1;
		    Seg_Type[i] = 3;				// оήType3
		  }
		  else{		// sigma_down[i] = -2 : д
		    mu_down[i] = new int[1];
		    while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
		    if(sscanf(pbuf, "%d", &mu_down_tmp) != 1){
		      printf("cannot scan mu_down when sigma_down equals to -2.");
		      exit(1);
		    }
				// sp_no[mu_down_tmp] = -2;
		    if(Seg_Type[i] != 2){
		      printf("Lake segment must have -2 in Connect file row of %d.\n", i);
		    }
		  }
		  i++;
		}
	}
	fclose(fp_connect);
	printf("Reading Connect file is done.\n");
}

