/* Read_Extracted.cc */
#include "Connect2SCF.h"

void Connect2SCF :: Read_Extracted()
{
	FILE* fp_extracted;
	char buf[256];
	char* pbuf;

	int ix, iy;		// åֹ
	int pnum;		// üֹ
	int snum;		// ƻʬֹ
	int pos;		// ü־

	int check;
	int num_of_need_seg_tmp = 0;
	int i,j;

	if((fp_extracted = fopen(extracted_file2, "r")) == NULL){
	printf("Connect2SCF\n");
	printf("Cannot open extracted file.\n");
	exit(1);
	}

	/* γ */
	need_seg = new int[Num_of_Seg];
	// 
	for(j=0; j<Num_of_Seg; j++){
	  need_seg[j] = 0;
	}

	while(fgets(buf, 256, fp_extracted) != NULL){
		if(strcmp(buf, "[Data Format Name]\n") != 0) continue;
		// [Data Format Name]ˤ.
		while(fgets(buf, 256, fp_extracted) != NULL){
			if(strcmp(buf, "plain format V.2\n") != 0){
				printf("Extracted File must be plain format V.2.\n");
				exit(1);
			}
			break;
		}
		break;
	}

	while(fgets(buf, 256, fp_extracted) != NULL){
		if(strcmp(buf, "[Data]\n") != 0) continue;
		// [Data]ˤ.
		while(fgets(buf, 256, fp_extracted) != NULL){
			if(sscanf(buf, "%d %d %d %d %d",
				&ix, &iy, &pnum, &snum, &pos) != 5){
				printf("[Data] in Extracted File is wrong");
				exit(1);
			}

			// ɬפʲƻʬֹ snum Ǥ.
			check = 0;
			for(j=0; j< Num_of_Seg; j++){
				if(seg_no[j] == snum) { // seg_no[j] ˤϲƻʬ³ե뤫ɤƻʬǼƤ
				  need_seg[j] = 1;
					check = 1;		// ɤ߹ƻʬ snum ޤޤƤУ
				}
			}
			if(check == 0){
			  printf("segment No.= %d that is included in Extracted file is not included in Connection file\n", snum);
			  //				exit(1);
			}
		}
	}

	// ɬײƻʬη׻
	for(j=0; j<Num_of_Seg; j++){
		if(need_seg[j] == 1){
			num_of_need_seg_tmp ++;
		}
		else if(need_seg[j] != 0){
			printf("need_seg[j] is not 1 nor 0");
			exit(1);
		}
	}
	Num_Of_Need_Seg = num_of_need_seg_tmp;
	printf("Number of Need Segment is %d\n", Num_Of_Need_Seg);
	fclose(fp_extracted);
	printf("Reading Extracted file is done.\n");
}




