/* Connect2SCF.cc */
#include "Connect2SCF.h"

Connect2SCF :: Connect2SCF(char* file)
{
  
  FILE* fp_file_file;
  char buf[256];

  char c_connect[256];
  char c_extracted[256];
  char c_removed[256];
  char c_header[256];
  char c_attr[256];
  char c_width[256];
  char c_dif[256];
  char c_difin[256];

  char c_scf[256];
  char c_pmt[256];
  char c_ist[256];


  file_file = file;

  if((fp_file_file = fopen(file_file, "r")) == NULL){
    printf("Connect2SCF\n");
    printf("Cannot open file_file.\n");
    exit(1);
  }


  while(fgets(buf, 256, fp_file_file) != NULL){

    // [Infile]T
    if(strcmp(buf, "[Infile]\n") == 0){

      // [Infile]ɂ

      // \`wb_[t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_header) == 1){
          strcpy(header_file, c_header);
          printf("Header File : \"%s\"\n", header_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // ڑt@C by makeConnect t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_connect) == 1){
          strcpy(connect_file, c_connect);
          printf("Connect File : \"%s\"\n", connect_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // Ώ͓ۗ by extractNetwork t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_extracted) == 1){
          strcpy(extracted_file2, c_extracted);
          printf("Extracted File : \"%s\"\n", extracted_file2);
        }
        else{
          printf("error in file_file");
        }
      }

      // ͓敪č\Ή\ by removeSegment t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_removed) == 1){
          strcpy(removed_segment_file, c_removed);
          printf("Removed File : \"%s\"\n", removed_segment_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // ͓ t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_attr) == 1){
          strcpy(attr_file, c_attr);
          printf("ATTR File : \"%s\"\n", attr_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // ͓t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_width) == 1){
          strcpy(width_file, c_width);
          printf("WIDTH File : \"%s\"\n", width_file);
        }
        else{
         printf("error in file_file");
        }
      }

      // `t@C̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_dif) == 1){
          strcpy(dif_file, c_dif);
          printf("DIF File : \"%s\"\n", dif_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // ӏݗpt@C(gpȂ)
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_difin) == 1){
         strcpy(difin_file, c_difin);
         printf("DIFIN File : \"%s\"\n", difin_file);
        }
        else{
          printf("error in file_file");
        }
      }
    }

    // [Outfile]T
    if(strcmp(buf, "[Outfile]\n") == 0){

      // \`t@C .DAT ̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_scf) == 1){
          strcpy(scf_file, c_scf);
          printf("SCF File : \"%s\"\n", scf_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // \`t@C .PMT ̓ǂݍ
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_pmt) == 1){
          strcpy(pmt_file, c_pmt);
          printf("PMT File : \"%s\"\n", pmt_file);
        }
        else{
          printf("error in file_file");
        }
      }

      // \`t@C .IST
      if(fgets(buf, 256, fp_file_file) != NULL){
        if(sscanf(buf, "%s", c_ist) == 1){
          strcpy(ist_file, c_ist);
          printf("IST File : \"%s\"\n", ist_file);
        }
        else{
          printf("error in file_file");
        }
      }
    }
  }
}
