/* Read_Diffluence.cc */
#include "Connect2SCF.h"

void Connect2SCF :: Read_Diffluence()
{
	FILE* fp_diffluence;
	int idummy, i, j;
	char buf[256];

	if((fp_diffluence = fopen(difin_file, "r")) == NULL){
		printf("Connect2SCF\n");
		printf("Cannot open diffluence file.\n");
		exit(1);
	}

	Total_Num_Of_Dif = 0;
	/* ̃JEg */
	while(fgets(buf, 256, fp_diffluence) != NULL){
		Total_Num_Of_Dif++;
	}
	// fp_diffluence ߂
	fseek(fp_diffluence, 0, 0);

	/* z̊m */
	Dif_Num = new int[Total_Num_Of_Dif];
	Num_Of_Dif = new int[Total_Num_Of_Dif];
	Dif_Down_Num = new int*[Total_Num_Of_Dif];
	Ratio = new float*[Total_Num_Of_Dif];

	// [ݒ
	for(j=0; j< Total_Num_Of_Dif; j++){
		Dif_Num[j] = 0;
		Num_Of_Dif[j] = 0;
		Dif_Down_Num[j] = 0;
		Ratio[j] = 0;
	}

	/* ̓ǂݍ */
	for(j=0; j < Total_Num_Of_Dif; j++){
		fscanf(fp_diffluence, "%d %d %d", &idummy, &Dif_Num[j], &Num_Of_Dif[j]);

		Dif_Down_Num[j] = new int[Num_Of_Dif[j]];
		for(i=0; i < Num_Of_Dif[j]; i++){
			fscanf(fp_diffluence, "%d", &Dif_Down_Num[j][i]);
		}

		Ratio[j] = new float[Num_Of_Dif[j]];
		for(i=0; i < Num_Of_Dif[j]; i++){
			fscanf(fp_diffluence, "%f", &Ratio[j][i]);
		}
		printf("Dif: from %d to %d and %d.\n", Dif_Num[j], Dif_Down_Num[j][0], Dif_Down_Num[j][1]);
		printf("with %f and %f.\n", Ratio[j][0], Ratio[j][1]);
	}
	printf("Reading Diffluence file is done.\n");
}
