/* Read_Removed_Segment.cc */
#include "Connect2SCF.h"

void Connect2SCF :: Read_Removed_Segment()
{
	FILE* fp_removed_segment;
	char buf[256];
	char* pbuf;
	
	int original;
	int num_of_updated;
	int updated;
	int check;
	int i,j;
	
	/* γ */
	removed_seg = new int[Num_of_Seg];
	if((fp_removed_segment = fopen(removed_segment_file, "r")) == NULL){
		printf("Connect2SCF\n");
		printf("Cannot open removed_segment file.\n");
		exit(1);
	}
	
	while(fgets(buf, 256, fp_removed_segment) != NULL){
	  pbuf = buf;
	  if(sscanf(pbuf, "%d %d", &original, &num_of_updated ) != 2){
	    printf("Cannot scan removed_segment");
	    exit(1);
	  }
	  
	  // original ¸ߤǧ
	  check = 0;
	  for(j=0; j< Num_of_Seg; j++){
	    if(seg_no[j] == original){
	      check = 1;		// ɤ߹ƻʬ original ޤޤƤУ
	      if(need_seg[j] == 1){
		if(num_of_updated > 1){
		  printf("Num_of_updated is supposed to be 1");
		  exit(1);
		}
		//		while((*pbuf == ' ') || (*pbuf =='\t')) pbuf++;
		if(sscanf(pbuf, "%d %d %d", &original, &num_of_updated, &updated) != 3){
		  printf("Cannot scan removed_segment(2)");
		  exit(1);
		}
		removed_seg[j] = updated;
	      }
	    }
	  }
	  //		if(check == 0){
	  //		  printf("segment No.=", original, "is not included, although removed_seg has it.");
	  //			  exit(1);
	  //		}
	}
	
	Num_Of_Removed = 0;
	// ƤɬײƻȤФƹΥֹ椬俶줿Ȥǧ롥
	for(j=0; j < Num_of_Seg; j++){
	  if(need_seg[j] == 1){
	    if(removed_seg[j] == 0){
	      printf("Seg_No : %d is not included in removed_seg file.\n", seg_no[j]);
	      printf("Should it be removed? yes -> 1, no -> 0 : ");
	      int ans = 0;
	      scanf("%d",&ans);
	      if(ans == 1){
		printf("Ok. Segment No. %d is now removed.\n", seg_no[j]);
		need_seg[j] = 0;
		Num_Of_Removed ++;
	      }
	      else{
		printf("error in Segment No. %d%\n", seg_no[j]);
		exit(1);
	      }
	    }
	  }
	}
	fclose(fp_removed_segment);
	printf("Reading Removed_Segment file is done.\n");
      }

